<template>
  <Layout>
    <div class="contenedor-empleados">
      <div class="agregar-empleado">
        <button
          type="button"
          class="btn btn-primary"
          data-bs-toggle="modal"
          data-bs-target="#registrarMovimiento"
        >
          Nuevo movimiento
        </button>
      </div>
      <div class="filtro">
        <form class="d-flex form-buscar-movimientos" role="search">
          <month-picker-input
            id="monthPicker"
            lang="es"
            :default-month="mesSeleccionado"
            :max-date="new Date()"
            :no-default="true"
            @input="changeDate"
          >
          </month-picker-input>
          <button class="btn btn-outline-primary" type="button" @click="applyFilter">Buscar</button>
        </form>
      </div>
      <div class="listado-movimientos">
        <table class="table table-striped table-hover" v-if="listadoMovimientos.length > 0">
          <thead>
            <tr>
              <th scope="col">No empleado</th>
              <th scope="col">Nombre</th>
              <th scope="col">Rol</th>
              <th scope="col">Horas trabajadas</th>
              <th scope="col">Cantidad entregas</th>
              <th scope="col">Pago total por entregas</th>
              <th scope="col">Bonos</th>
              <th scope="col">Retenciones ISR</th>
              <th scope="col">Vales de despenza</th>
              <th scope="col">Sueldo neto</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="movimiento in listadoMovimientos" :key="movimiento.id">
              <th scope="row">{{ movimiento.noemployee }}</th>
              <td>{{ movimiento.name }}</td>
              <td>{{ movimiento.description }}</td>
              <td>{{ movimiento.hours }}</td>
              <td>{{ movimiento.deliveries }}</td>
              <td>{{ toCurrency(+movimiento.paymentdeliveries) }}</td>
              <td>{{ toCurrency(+movimiento.bonus) }}</td>
              <td>
                {{ toCurrency(+movimiento.retentionisr + +movimiento.extraretentionisr) }}
              </td>
              <td>{{ toCurrency(+movimiento.pantryvouchers) }}</td>
              <td>{{ toCurrency(+movimiento.salary) }}</td>
            </tr>
          </tbody>
        </table>

        <div v-if="listadoMovimientos.length < 1" class="sin-contenido">
          <p class="sin-info">
            No se han encontrado resultados en la búsqueda, por favor vuelva a intentarlo.
          </p>
        </div>
      </div>
    </div>

    <Modal
      titulo="Registrar movimiento"
      textButtonSave="Guardar"
      textButtonClose="Cerrar"
      identificador="registrarMovimiento"
      @clickGuardar="createMovement"
    >
      <form action="#" class="form-floating login-form">
        <div class="form-floating mb-3">
          <input
            type="number"
            class="form-control"
            placeholder="Número de empleado*"
            id="noEmpleado"
            v-model="noEmpleado"
            required
            @keyup="searchEmployee($event)"
          />
          <label for="noEmpleado">Número de empleado*</label>
        </div>
        <div class="form-floating mb-3">
          <input
            type="text"
            class="form-control rounded-left"
            placeholder="Nombre*"
            id="nombreEmpleado"
            v-model="nombreEmpleado"
            required
            disabled
          />
          <label for="nombreEmpleado">Nombre*</label>
        </div>
        <div class="form-floating mb-3">
          <input
            type="text"
            class="form-control rounded-left"
            placeholder="Rol*"
            id="rolEmpleado"
            v-model="rolEmpleado"
            required
            disabled
          />
          <label for="rolEmpleado">Rol*</label>
        </div>
        <div class="form-floating mb-3">
          <month-picker-input
            id="monthPickerMov"
            lang="es"
            :default-month="mesSeleccionadoMov"
            :max-date="new Date()"
            :no-default="true"
            @input="changeDateMov"
          >
          </month-picker-input>
        </div>
        <div class="form-floating mb-3">
          <input
            type="number"
            class="form-control rounded-left"
            placeholder="Entregas*"
            id="entregasEmpleado"
            v-model="entregasEmpleado"
            required
            :disabled="disabledInput"
            @keyup="cleanError"
          />
          <label for="entregasEmpleado">Entregas*</label>
        </div>
      </form>
      <div class="contenedor-error" v-if="apiError != ''">
        {{ apiError }}
      </div>
    </Modal>
    <Modal
      v-if="tokenExpired"
      titulo="Cierre de sesion"
      textButtonSave="Cerrar sesion"
      :showButtonClose="false"
      @clickGuardar="logOut"
      identificador="sessionExpired"
      :hidden="false"
    >
      <p>Estimado usuario, tu sesion ha expirado.</p>
    </Modal>
  </Layout>
</template>

<script>
import Layout from '../layouts/Layout.vue'
import Modal from '../components/Modal.vue'
import { MonthPickerInput } from 'vue-month-picker'
import serviceMovementos from '../services/movements'
import serviceEmployees from '../services/employees'
import { useSesionUsuario } from '../stores/user'

export default {
  name: 'Movements',
  components: {
    Layout,
    Modal,
    MonthPickerInput
  },
  data() {
    return {
      mesSeleccionado: new Date().getMonth() + 1,
      yearSeleccionado: new Date().getFullYear(),
      mesSeleccionadoMov: new Date().getMonth() + 1,
      yearSeleccionadoMov: new Date().getFullYear(),
      listadoMovimientos: [],
      disabledInput: true,
      noEmpleado: '',
      nombreEmpleado: '',
      rolEmpleado: '',
      empleadoId: null,
      entregasEmpleado: null,
      apiError: '',
      tokenExpired: false
    }
  },
  beforeMount() {
    this.getMovements()
  },
  methods: {
    getMesActual() {
      const month = [
        'Enero',
        'Febrero',
        'Marzo',
        'Abril',
        'Mayo',
        'Juneo',
        'Julio',
        'Agosto',
        'Septiembre',
        'Octubre',
        'Noviembre',
        'Diciembre'
      ]

      const d = new Date()

      return `${month[d.getMonth()]} del ${d.getFullYear()}`
    },
    changeDate(data) {
      this.mesSeleccionado = data.monthIndex
      this.yearSeleccionado = data.year
    },
    changeDateMov(data) {
      this.cleanError()
      this.mesSeleccionadoMov = data.monthIndex
      this.yearSeleccionadoMov = data.year
    },
    applyFilter() {
      this.getMovements()
    },
    async getMovements() {
      try {
        const response = await serviceMovementos.getMovements(
          this.mesSeleccionado,
          this.yearSeleccionado
        )

        this.listadoMovimientos = response
      } catch (error) {
        this.tokenExpired = error?.response?.data?.tokenExpired || false
        this.listadoMovimientos = []
      }
    },
    async searchEmployee(event) {
      this.cleanError()
      if (event.which === 13) {
        try {
          const response = await serviceEmployees.getByNoEmployee(this.noEmpleado)

          this.nombreEmpleado = response.name
          this.rolEmpleado = response.description
          this.empleadoId = response.id
          this.disabledInput = false
        } catch (error) {
          this.tokenExpired = error?.response?.data?.tokenExpired || false
          this.nombreEmpleado = ''
          this.rolEmpleado = ''
          this.empleadoId = null
          this.disabledInput = true
          this.apiError = error?.response?.data?.msg || ''
        }
      }
    },
    async createMovement() {
      try {
        const response = await serviceMovementos.registerMovement(
          this.mesSeleccionadoMov,
          this.yearSeleccionadoMov,
          this.empleadoId,
          this.entregasEmpleado
        )

        if (response.error === false) {
          document.getElementById('btn-close').click()
          this.listadoMovimientos = []
          this.getMovements()
          this.cleanNewMovementForm()
        } else this.apiError = response.msg
      } catch (error) {
        this.tokenExpired = error?.response?.data?.tokenExpired || false
        this.apiError = error?.response?.data?.msg || 'Ocurrió un error al guardar el movimiento, intente de uevo.'
      }
    },
    cleanError() {
      this.apiError = ''
    },
    cleanNewMovementForm() {
      this.noEmpleado = ''
      this.nombreEmpleado = ''
      this.rolEmpleado = null
      this.empleadoId = null
      this.entregasEmpleado = null
    },
    async logOut() {
      const sesionUsuario = useSesionUsuario()
      try {
        useSesionUsuario.cerrarSesion()
        this.$router.push({ name: 'login' })
      } catch (error) {
        sesionUsuario.cerrarSesion()
        this.$router.push({ name: 'login' })
      }
    },
    toCurrency(value) {
      if (typeof value !== 'number') {
        return value
      }
      var formatter = new Intl.NumberFormat('en-US', {
        style: 'currency',
        currency: 'USD'
      })

      return formatter.format(value)
    }
  }
}
</script>

<style scoped>
.contenedor-error {
  display: flex;
  justify-content: center;
  color: #f16a6a;
}
.form-buscar-movimientos {
  width: 100%;
  gap: 15px;
  justify-content: flex-end;
  margin: 15px 0;
}
.sin-contenido {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  min-height: 300px;
  text-align: center;
}
.table {
  text-align: center;
}
</style>
<style>
#monthPicker input {
  height: 40px;
  padding: 0 1.5em !important;
  width: 100% !important;
}

#monthPicker {
  width: 304px;
}

#monthPickerMov {
  width: 100%;
}
#monthPickerMov input {
  width: 100%;
}
</style>
